// hand.as

if (Object.Swim == null) {
	Object.Swim = {};
}

if (Object.Swim.Hand == null) {
	Object.Swim.Hand = {};
}

var Hand = Object.Swim.Hand;

Hand.initHand = function ( maxCards, showMe) {
	findProto(Object.Swim.Hand).implement (Object.Screen.Generic);
	this.initScreenGeneric(showMe);

	if (maxCards != null && Number(maxCards>=1) ) {
		this.maxCards = maxCards;
	} else {
		this.maxCards = 3;
	}
	this.resetHand();
} // initHand

Hand.resetHand = function () {
	this.cards = [];
} // resetHand


Hand.hideHand = function () {
	for (var i=0; i<maxCards; i++) {
		this.cards[i].hide();
	}
} // hideHand

Hand.hide = function () {
	this.hideHand();

	this._hide = findProto (Object.Screen.Generic).hide;
	this._hide();
	delete this._hide;
} // hide

Hand.showHand = function () {
	for (var i=0; i<maxCards; i++) {
		this.cards[i].show();
	}
} // showHand

Hand.show = function () {
	this.showHand();
	
	this._show = findProto (Object.Screen.Generic).show;
	this._show();
	delete this._show;
} // show

Hand.placeCard = function (slot, card) {
	var xPos = slot * (card._width + 7);
	var point = { x : xPos, y : 0 };
	card.placeClip ( point, this );
} // placeCard

Hand.setCard = function (slot, card) {
	this.cards[slot] = card;
	this.placeCard (slot, card); 
} // setCard

Hand.setAllCards = function (cardArray) {	
	for (var i=0; i<maxCards; i++) {
		this.setCard (i, cardArray[i]);
	}
} // setAllCards

Hand.getCard = function (slot) {
	return this.cards[slot];
} // getCard

Hand.getAllCards = function () {
	var allCards = [];
	for (var i=0; i<maxCards; i++) {
		allCards[i] = this.cards[i];
	}
	return allCards;
} // getAllCards

Hand.analyzeHand = function (cardArray) {
	// analyzes the score of a hand
	var score = 0;
	var scores = { };
	var card, suit, value, face;
	var sameFace = true;
	var scoreFace;
	var myCards;
	
	cardArray == null ?
		myCards = this.cards :
		myCards = cardArray;
	 
	for (var i=0; i<this.maxCards; i++) {
		card = myCards[i];
		if (card != null) {
			suit = card.getsuitDesc();
			value = card.getValue();
			face = card.getFace();
			
			scores[suit] == null ? scores[suit] = value : scores[suit] += value;
			
			// keep track of the face
			if (scoreFace == null) {
				scoreFace = face;
			} else if (scoreFace != face) {
				sameFace = false;
			}
		}
	}
	
	if (sameFace) {
		// three of a kind
		score = 30.5;
	} else {
		// regular score, find the highest one
		for (var suit in scores) {
			if (scores[suit] > score) {
				score = scores[suit];
			}
		}
	}
	
	this.scores = scores;
	this.score 	= score;
	
	// return this.getScore();
} // analyze hand

Hand.getScore = function () {
	return this.score;
} // getScore

// done. delete shortcut
delete Hand;