// player.as

if (Object.Swim == null) {
	Object.Swim = {};
}

if (Object.Swim.Player == null) {
	Object.Swim.Player = {};
}

var Player = Object.Swim.Player;

Player.initPlayer = function (id, maxCards, chances, showMe, playerName) {
	var myProto = findProto(Object.Swim.Player);
	myProto.implement (Object.Swim.Hand);
	
	this.initHand (maxCards, showMe);
	
	this.id = id;
	
	playerName != null && playerName != "" ?
		this.playerName = playerName :
		this.playerName = "Player " + (id+1);
	
	this.maxChances = chances;
	this.chances 		= this.maxChances;
	
	this.reset();
	this.startRound();
} // initPlayer

Player.reset = function () {
	this.resetChances();
	this.resetHand();
	this.hide();
} // reset

Player.startRound = function () {
	this.firstTurn = true;
} // startRound

Player.endOfTurn = function () {
	this.analyzeHand();
	if (this.firstTurn) {
		this.firstTurn = false;
	}
	_parent.nextTurn();
} // endOfTurn

Player.getChances = function () {
	return this.chances;
} // getChances

Player.loseChance = function () {
	this.chances--;
	return this.getChances();
} // loseChance

Player.resetChances = function () {
	this.chances = this.maxChances;
	return this.getChances();
} // resetChances

Player.getPlayerName = function () {
	return this.playerName;
} // getPlayerName

Player.changeCard = function (slot, stackSlot) {
	var dropCard = this.cards[slot];
	var newCard = _parent.stack.getCard (stackSlot); 
	
	_parent.stack.setCard (stackSlot, dropCard);
	this.setCard (slot, newCard);
} // changeCard

Player.changeAllCards = function () {
	for (var i=0; i<this.maxCards; i++) {
		this.changeCard (i,i);
	}
} // changeAllCards

Player.takeOne = function (slot, stackSlot) {
	if (slot == null) {
		slot = Number (substring(this.currentSlot,5));
	}

	if (stackSlot == null) {
		stackSlot = Number (substring (this.currentStack,6));
	}
	changeCard (slot, stackSlot);
	_parent.recordMove ("takeOne", stackSlot, this.stackCards[stackslot]);
	endOfTurn();
} // takeOne

Player.takeAll = function () {
	changeAllCards();
	_parent.recordMove ("takeAll", this.stackCards);
	endOfTurn();
} // take all

Player.pass = function () {
	_parent.recordMove ("pass");
	endOfTurn();
} // pass

Player.knock = function () {
	if (!this.firstTurn) {
		_parent.recordMove ("knock");
		endOfTurn();
	}
} // knock

Player.yourTurn = function ( lastMoves ) {
	this.lastMoves = lastmoves;
	this.stackCards = _parent.stack.getAllCards();
} // yourTurn

delete Player;
