/**
 * A ridiculously simple (and lightweight) logger. It doesn't really do much,
 * but I'm using it in order to keep the logging code in a central location.
 *
 * @author Christian Cantrell
 * @version $Id: PocketLogger.java,v 1.6 2001/09/09 05:05:39 cantrell Exp $
 */
public class PocketLogger
{
    private static PocketLogger logger;

    /**
     * Get an instance of the PocketLogger. This is the only way to get an
     * instance so I can ensure that there is only one per JVM.
     */
    public static PocketLogger getInstance()
    {
        if (logger == null)
        {
            logger = new PocketLogger();
        }
        return logger;
    }

    private PocketLogger()
    {
        // Defeat instiantiation.
    }

    public void log(String msg)
    {
        log(msg, null);
    }

    public void log(String msg,
                    Exception exception)
    {
        System.out.println(msg);
        if (exception != null)
        {
            exception.printStackTrace();
        }
    }
}
