/**
 * Utility for URL de-coding. Unfortunately, 1.1.8 does not have a tool for
 * this type of thing, so I had to write one myself.
 *
 * @author Christian Cantrell
 * @version $Id: URLDecoder.java,v 1.4 2001/09/09 05:05:39 cantrell Exp $
 */ 
public class URLDecoder
{
    private static char[] hexChars = new char[] {'0','1','2','3','4','5','6',
                                                 '7','8','9','a','b','c','d',
                                                 'e','f'};
    public static String decode(String str)
    {
        char[] chars = str.toCharArray();
        int len = chars.length;
        StringBuffer result = new StringBuffer();
        for (int i = 0; i < len; ++i)
        {
            switch (chars[i])
            {
                case '+':
                    result.append(' ');
                    break;
                case '%':
                    int a = getPos(chars[++i]);
                    int b = getPos(chars[++i]);
                    int c = b + (a * 16);
                    result.append((char)c); 
                    break;
                default:
                    result.append(chars[i]);
                    break;
            }
        }
        return result.toString();
    }

    private static int getPos(char c)
    {
        for (int i = 0; i < 16; ++i)
        {
            if (Character.toLowerCase(c) == hexChars[i])
            {
                return i;
            }
        }
        return -1;
    }
}
