/*
	button_ppc.as

*/

if (Object.Button == null) {
	Object.Button = {};
}

Object.Button.initButton = function (mode) {
	this.states = {
		off				: "off"
		,active 	: "active"
		,over 		: "over"
		,down			: "down"
		,selected : "selected"
		,hide			: "hide"
	}

	if (mode != null && this.states[mode] != null) {
		this.set ( mode );
	} else {
		this.set ( this.states["off"] );
	}
}

Object.Button.set = function (mode) {
	if (mode != null && this.states[mode] != null) {
		this.state = this.states[mode];
		if (this.state != this.states.hide) {
			this._visible = true;
			this.gotoAndStop (this.state);
		} else {
			this._visible = false;
			this.gotoAndStop (this.states.off);			
		}
	}
}

Object.Button.hide = function () {
	// a shortcut to hide a button
	this.set (this.states.hide); 
}

Object.Button.get = function () {
	return this.state;
}

// 
// button event handlers
//

Object.Button.btnRollOver = function () {
	this.set (this.states.over);
}

Object.Button.btnRollOut = function () {
	this.set (this.states.active);
}

Object.Button.btnPress = function () {
	this.set (this.states.over);
	_parent.buttonPress (this);
}

Object.Button.btnRelease = function () {
	_parent.buttonRelease (this);
}

Object.Button.btnReleaseOutside = function () {
	this.set (this.states.active);
}

Object.Button.btnDragOut = function () {
	this.set (this.states.active);
}

Object.Button.btnDragOver = function () {
	this.set (this.states.over);
}
