// screen_generic.as

if (Object.Screen == null ) { 
	Object.Screen = {};
}

if (Object.Screen.Generic == null) {
	Object.Screen.Generic = {};
}

Object.Screen.Generic.initScreenGeneric = function (showMe) {
	(showMe) ? this.show() : this.hide();
	/*
	In case you're not familiar with the ternary operator (?), 
	you can read like a question:
	If the expression on the left (showMe) returns true, 
	the first action on the right will be executed (this.show()), 
	otherwise the action after the column (this.hide())
	
	This is a convenient shortcut to replace a if-then-else construct 
	with only one action in each clause.
	This is equivalent to writing
	if (showMe) {
		this.show();
	} else {
		this.hide();
	}
	
	*/
}

Object.Screen.Generic.hide = function () {
	this._visible = false;
}

Object.Screen.Generic.show = function () { 
	this._visible = true;
}

Object.Screen.Generic.buttonRelease = function (button) {
	/*
		placeholder release handler
		overwrite with your handler
	
		release should be used for most device button click reactions
		since there is no rollover
	*/
}

Object.Screen.Generic.buttonPress = function (button) {
	// generic press handler
	// overwrite if necessary (e.g. for dragging)
}